package model

import (
	"errors"

	"github.com/zeromicro/go-zero/core/stores/sqlx"
)

var ErrNotFound = sqlx.ErrNotFound
var ErrNoRowsUpdate = errors.New("update db no rows change")

// 平台
var PlatformWxMini string = "wxmini"
var PlatformWxH5 string = "wxh5"
var PlatformApp string = "app"
var PlatformH5 string = "h5"
var PlatformAdmin string = "admin"

// 用户授权类型
var UserAuthTypeMobile string = "mobile"
var UserAuthTypeWxMiniOpenID string = "wxmini_openid"
var UserAuthTypeWxh5OpenID string = "wxh5_openid"
var UserAuthTypeUUID string = "uuid"

// 代理扣除类型
var AgentDeductionTypeCost string = "cost"
var AgentDeductionTypePricing string = "pricing"

// 代理奖励类型
var AgentRewardsTypeDescendantPromotion string = "descendant_promotion"
var AgentRewardsTypeDescendantUpgradeVip string = "descendant_upgrade_vip"
var AgentRewardsTypeDescendantUpgradeSvip string = "descendant_upgrade_svip"
var AgentRewardsTypeDescendantStayActive string = "descendant_stay_active"
var AgentRewardsTypeDescendantNewActive string = "descendant_new_active"
var AgentRewardsTypeDescendantWithdraw string = "descendant_withdraw"

// 代理等级名称
var AgentLeveNameNormal string = "normal"
var AgentLeveNameVIP string = "VIP"
var AgentLeveNameSVIP string = "SVIP"

// 订单状态
const (
	OrderStatusPending  = "pending"
	OrderStatusPaid     = "paid"
	OrderStatusFailed   = "failed"
	OrderStatusRefunded = "refunded"
	OrderStatusClosed   = "closed"
)

// 订单退款状态
const (
	OrderRefundStatusPending = "pending"
	OrderRefundStatusSuccess = "success"
	OrderRefundStatusFailed  = "failed"
	OrderRefundStatusClosed  = "closed"
)

// 查询状态
const (
	QueryStatePending    = "pending"
	QueryStateFailed     = "failed"
	QueryStateSuccess    = "success"
	QueryStateProcessing = "processing"
	QueryStateCleaned    = "cleaned"
)

// 授权类型
const (
	AuthorizationGrantTypeFace = "face"
	AuthorizationGrantTypeSms  = "sms"
)

// 授权状态
const (
	AuthorizationStatusPending  = "pending"
	AuthorizationStatusSuccess  = "success"
	AuthorizationStatusFailed   = "failed"
	AuthorizationStatusExpired  = "expired"
	AuthorizationStatusRevoked  = "revoked"
	AuthorizationStatusRejected = "rejected"
)

// 授权人脸状态
const (
	AuthorizationFaceStatusPending = "pending"
	AuthorizationFaceStatusSuccess = "success"
	AuthorizationFaceStatusFailed  = "failed"
)

// 代理实名状态
const (
	AgentRealNameStatusPending  = "pending"
	AgentRealNameStatusApproved = "approved"
	AgentRealNameStatusRejected = "rejected"
)

// 用户身份类型
const (
	UserTypeTemp   = 0 // 临时用户
	UserTypeNormal = 1 // 正式用户
	UserTypeAdmin  = 2 // 管理员
)

// 代理状态
const (
	AgentStatusNo  = 0 // 非代理
	AgentStatusYes = 1 // 是代理
)
